<?php 

function base_to_meta($image){
      $info_meta['lat']=$image['lat'];
      $info_meta['lon']=$image['lon'];
      $info_meta['alt']=$image['alt']; 
      //===========================================================================
      $info_meta['latRef'] = ($image['lat']<0)? 'S' : "N" ;
      $info_meta['GPSLatitudeRef'] = ($image['lat']<0)? 'S' : "N" ;
      $p1=dec2dms($image['lat']);
 
      $info_meta['latDMS']=$p1[0]['Numerator']  . "/" .
            $p1[0]['Denominator'] ." ".
            $p1[1]['Numerator'] . "/" .
            $p1[1]['Denominator'] ." ".
            $p1[2]['Numerator'] . "/" .
            $p1[2]['Denominator'] ;

      $info_meta['GPSLatitude']=array(
            $p1[0]['Numerator']  . "/" .
            $p1[0]['Denominator'] ,
            $p1[1]['Numerator'] . "/" .
            $p1[1]['Denominator'] ,
            $p1[2]['Numerator'] . "/" .
            $p1[2]['Denominator']
            );

      //===========================================================================
      $info_meta['GPSLongitudeRef']  = ($image['lon']<0)? 'W' : "E" ;
      $info_meta['lonRef']  = ($image['lon']<0)? 'W' : "E" ;
      $p1=dec2dms($image['lon']);
      $info_meta['lonDMS']=$p1[0]['Numerator']  . "/" .
            $p1[0]['Denominator'] ." ".
            $p1[1]['Numerator'] . "/" .
            $p1[1]['Denominator'] ." ".
            $p1[2]['Numerator'] . "/" .
            $p1[2]['Denominator'] ;
      $info_meta['GPSLongitude']=array(
            $p1[0]['Numerator']  . "/" .
            $p1[0]['Denominator'] ,
            $p1[1]['Numerator'] . "/" .
            $p1[1]['Denominator'] ,
            $p1[2]['Numerator'] . "/" .
            $p1[2]['Denominator']
            );
      //===========================================================================
        $info_meta['GPSAltitudeRef'] = "0";
        $p1= round( $image['alt'] * 5000000000 );
        $info_meta['GPSAltitude']= $p1.'/'."500000000000"; 
        $info_meta['altDMS']= $p1.'/'."500000000000"; 
        $info_meta['altRef']= "0"; 
  return $info_meta ;
}

/**********************************
* DECIMAL TO FRACTION             *
**********************************/ 
  function dec2frac( $decimal ) {
    $decimal = (string)$decimal;
    $num = '';
    $den = 1;
    $dec = false;

    // find least reduced fractional form of number
    for( $i = 0, $ix = strlen( $decimal ); $i < $ix; $i++ ){
     // build the denominator as we 'shift' the decimal to the right
     if( $dec ) $den *= 10;

     // find the decimal place/ build the numberator
     if( $decimal{$i} == '.' ) $dec = true;
     else $num .= $decimal{$i};
    }
    $num = (int)$num;
 if(empty($ret1)) $ret1=(object) '';
    // whole number, just return it
    if( $den == 1 ) {
        $ret1->Numerator =($num ) ;
        $ret1->Denominator=($den);
    return $ret1;
    }
    $num2 = $num;
    $den2 = $den;
    $rem  = 1;
    // Euclid's Algorithm (to find the gcd)
    while( $num2 % $den2 ) {
     $rem = $num2 % $den2;
     $num2 = $den2;
     $den2 = $rem;
    }
        if( $den2 != $den ) $rem = $den2;
       
        $ret1->Numerator =($num / $rem ) ;
        $ret1->Denominator=($den / $rem);
     
    // now $rem holds the gcd of the numerator and denominator of our fraction
    return $ret1;
  }

/**********************************
* Decimal vers Deg Min Sec        *
**********************************/ 
function dec2dms($value) { 
        $value= abs($value);
        $degrees= floor($value);
        $tmp=($value-$degrees)*60; 
        $minutes= floor($tmp); 
        $seconds= round(($tmp-$minutes)*6000)/100;
       
        $sec =  dec2frac($seconds);

   //if(empty($ret1)) $ret1=(object) ;
   $ret=array();

        $ret[0]['Numerator'] =$degrees ;
        $ret[0]['Denominator'] = 1 ;        
        $ret[1]['Numerator']  = $minutes ;
        $ret[1]['Denominator']= 1;  
        if($sec->Numerator){
            $ret[2]['Numerator']  = $sec->Numerator ;
            $ret[2]['Denominator']= $sec->Denominator;
        }
  $ret[3]= " Deg: " . $degrees . " Min: " . $minutes . " Sec: " . $seconds."  " ;
        $ret[4]= " " . $degrees . "/1 " . $minutes . "/1 " . $sec->Numerator."/".$sec->Denominator ; 

return( $ret); 

}


function toFraction($number){

echo  ($number)."<br />" ;
$numerator = 1; 
$denominator = 0; 
$reste1->min =$number;


for(  ; $numerator < 100; $numerator++){ 

$temp =   ($numerator / $number);
$reste=ceil($temp) - $temp;
echo "<br />
$reste --- $reste1->min " ; 
if ($reste<$reste1->min) {
        $reste1->numerator = $numerator;
        $reste1->min =$reste ;
        $reste1->denominator =$temp ;
}

    if(ceil($temp) - $temp == 0){ 
                $denominator = $temp;
                 break;
        } 
} 
echo "<br />". $reste1->numerator . " /  " .$reste1->denominator ;

return ($denominator > 0) ? $numerator . '/' . $denominator : false; 
} 
//==============================================
 function Parse_Fract( $f ){
  $nd = explode( '/', $f );
  return $nd[0]/$nd[1];
}
 
function Parse_Lat_Lon( $arr )
{
  $v=0;
  $v += parse_fract( $arr[0] );
  $v += parse_fract( $arr[1] )/60;
  $v += parse_fract( $arr[2] )/3600;
  return $v;
}
?>